
// GraphDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Graph.h"
#include "GraphDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static int total[60];
int Rows = 0;
CString Temp;

CGraphDlg::CGraphDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGraphDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MSCHART1, m_chart);
}

BEGIN_MESSAGE_MAP(CGraphDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()

void CGraphDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting			
	}
	else
	{
		CDialog::OnPaint();
	}
}
HCURSOR CGraphDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// CGraphDlg message handlers

BOOL CGraphDlg::OnInitDialog()
{
	CDialog::OnInitDialog();	
	SetIcon(m_hIcon, TRUE);			//put_ big icon
	SetIcon(m_hIcon, FALSE);		//put_ small icon
   
	//m_chart
	m_chart.SetRowLabel("Row");
	m_chart.SetColumnLabel("Column");

	GetChartData();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}    

void CGraphDlg::GetChartData()
{      
 
	for(int AF=0;AF<60;AF++) total[AF] = 500;

   m_dwrawdatadetails.clear();
   Rows=0;
   for(int Row=0;Row<60;Row++)
   {
     DWRAWDATADETAILS RDStru;
     Temp.Format(" %d",Row);
     RDStru.Label = Temp ;
	 Temp.Format("%d",total[Row]);
	 RDStru.Count = Temp;
     m_dwrawdatadetails.insert(m_dwrawdatadetails.end(),RDStru);
	 Rows++;
   } 
   AddOrUpdateChartData(Rows);
}

int CGraphDlg::AddOrUpdateChartData(int RevNoRows)
{	
	COleSafeArray saRet;
	SAFEARRAYBOUND sab[2];
	sab[0].cElements = RevNoRows;
	sab[1].cElements = 2; 
	sab[0].lLbound = sab[1].lLbound = 1;
    saRet.Create(VT_BSTR, 2, sab);
	long index[2] = {0,0}; 
	BSTR bstr;
	index[0]=1;

	DWRAWDATADETAILS filedetailsstruct;
	CString cstemp;
		
	m_chart.SetChartType(3);
	for(i=m_dwrawdatadetails.begin();i!=m_dwrawdatadetails.end();i++)
	{
	  filedetailsstruct =(DWRAWDATADETAILS)*i;
      index[1] = 1;
	  bstr = filedetailsstruct.Label.AllocSysString(); 
	  saRet.PutElement(index, bstr);
	  index[1]=2;
	  bstr = filedetailsstruct.Count.AllocSysString(); // Data for column 1
	  ::SysFreeString(bstr);
      saRet.PutElement(index, bstr);
      index[0]++; 
	}
	m_chart.SetChartData(saRet.Detach()); 

	return 1;
}
